<template>
    <div class="container-fluid">
        <div class="row" style="margin-bottom: 15px">
            <div class="col-md-3 offset-9 text-right">
                <button class="btn btn-info" @click="openModal">
                    NUEVO GASTO
                </button>
            </div>
        </div>
        <div class="row">
            <div class="col-sm">
                <table class="table table-hover">
                    <thead>
                    <tr>
                        <th scope="col">#</th>
                        <th scope="col">Categoria</th>
                        <th scope="col">Fecha</th>
                        <th scope="col">Empleado</th>
                        <th scope="col">Departmaneto</th>
                        <th scope="col">Cantidad</th>
                        <th scope="col">% Impuestos</th>
                        <th scope="col">Impuestos</th>
                        <th scope="col">Metodo de pago</th>
                        <th scope="col">-</th>
                        <th scope="col">-</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="gasto in gastos" :key="gasto.id">
                        <td>{{gasto.id}}</td>
                        <td>{{gasto.expense_category.name}}</td>
                        <td>{{gasto.created_at | moment('L')}}</td>
                        <td>{{gasto.employee.name}} {{gasto.employee.last_name}}</td>
                        <td>{{gasto.employee.department.name}}</td>
                        <td>{{gasto.amount / 100 | toCurrency}}</td>
                        <td>{{gasto.tax_percentage}} %</td>
                        <td>{{gasto.TaxC | toCurrency}}</td>
                        <td>{{gasto.payment_method.name}}</td>
                        <td>
                            <button type="button" class="btn btn-info" @click="editModal(gasto)">
                                <span class="oi oi-pencil" style="color: white"></span>
                            </button>
                        </td>
                        <td>
                            <button type="button" class="btn btn-danger" @click="deleteItem(gasto)">
                                <span class="oi oi-trash" style="color: white"></span>
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </div>
        <!--Modales-->
        <div class="modal fade" ref="gastom" id="nuevoGasto" tabindex="-1" role="dialog"
             aria-labelledby="nuevoGastoLabel"
             aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="nuevoGastolLabel">Nuevo gasto</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <form @submit.prevent="saveData">
                        <div class="modal-body">
                            <div class="form-group">
                                <label for="employee">Empleado</label>
                                <select class="form-control" v-model="gastoData.employee">
                                    <option v-for="employee in employees" :key="employee.id" :value="employee.id">
                                        {{employee.name}} {{employee.last_name}}
                                    </option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="category">Categoria</label>
                                <select class="form-control" v-model="gastoData.category">
                                    <option v-for="category in categories" :key="category.id" :value="category.id">
                                        {{category.name}}
                                    </option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="paymentMethod">Metodo de pago</label>
                                <select class="form-control" v-model="gastoData.paymentMethod">
                                    <option v-for="paymentMethod in paymentMethods" :key="paymentMethod.id"
                                            :value="paymentMethod.id">
                                        {{paymentMethod.name}}
                                    </option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="amount">Cantidad</label>
                                <input type="number" class="form-control" v-model="gastoData.amount"
                                       placeholder="Cantidad gastada">
                            </div>
                            <div class="form-group">
                                <label for="amount">Impuestos</label>
                                <input type="number" class="form-control" v-model="gastoData.percentage"
                                       placeholder="% de impuesto">
                            </div>

                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
                            <button type="submit" class="btn btn-primary">Guardar</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <div class="modal fade" ref="gastom" id="editGasto" tabindex="-1" role="dialog"
             aria-labelledby="editGastoLabel"
             aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="editGastoLabel">Nuevo gasto</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <form @submit.prevent="editData">
                        <div class="modal-body">
                            <div class="form-group">
                                <label for="employee">Empleado</label>
                                <select class="form-control" v-model="gastoData.employee">
                                    <option v-for="employee in employees" :key="employee.id" :value="employee.id">
                                        {{employee.name}} {{employee.last_name}}
                                    </option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="category">Categoria</label>
                                <select class="form-control" v-model="gastoData.category">
                                    <option v-for="category in categories" :key="category.id" :value="category.id">
                                        {{category.name}}
                                    </option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="paymentMethod">Metodo de pago</label>
                                <select class="form-control" v-model="gastoData.paymentMethod">
                                    <option v-for="paymentMethod in paymentMethods" :key="paymentMethod.id"
                                            :value="paymentMethod.id">
                                        {{paymentMethod.name}}
                                    </option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="amount">Cantidad</label>
                                <input type="number" class="form-control" v-model="gastoData.amount"
                                       placeholder="Cantidad gastada">
                            </div>
                            <div class="form-group">
                                <label for="amount">Impuestos</label>
                                <input type="number" class="form-control" v-model="gastoData.percentage"
                                       placeholder="% de impuesto">
                            </div>

                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
                            <button type="submit" class="btn btn-primary">Guardar</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: "Gastos",
        data: () => ({
            gastos: [],
            editIndex: -1,
            gastoData: {
                employee: 1,
                category: 1,
                paymentMethod: 1,
                amount: 0,
                percentage: 0
            },
            defaultGastoData: {
                employee: 1,
                category: 1,
                paymentMethod: 1,
                amount: 0,
                percentage: 0
            },
            employees: [],
            categories: [],
            paymentMethods: []
        }),
        methods: {
            getExpenses() {
                window.axios.get('/api/getGastos').then((response) => {
                    this.gastos = response.data.expenses
                })
            },
            getEmployees() {
                window.axios.get('/api/getEmployees').then((response) => {
                    this.employees = response.data.employees
                })
            },
            getExpenseCategory() {
                window.axios.get('/api/getExpenseCategory').then((response) => {
                    this.categories = response.data.expCategory
                })
            },
            getPaymentMethod() {
                window.axios.get('/api/getPaymentMethod').then((response) => {
                    this.paymentMethods = response.data.paymentMethods
                })
            },
            openModal() {
                // console.log($('#nuevoGasto'));
                $('#nuevoGasto').modal()
            },
            saveData() {
                window.axios.post('/api/newExpense', this.gastoData).then((response) => {
                    this.gastos.unshift(response.data.expense)
                    $('#nuevoGasto').modal('toggle')
                    this.gastoData = JSON.parse(JSON.stringify(this.defaultGastoData))
                }).catch((error) => {
                    // Solo se mostrara error en la consola
                    console.log(error)
                })
            },
            editModal(item) {
                this.editIndex = this.gastos.indexOf(item)
                this.gastoData.amount = item.amount / 100
                this.gastoData.employee = item.employee_id
                this.gastoData.category = item.expense_category_id
                this.gastoData.paymentMethod = item.expense_payment_method_id
                this.gastoData.percentage = item.tax_percentage
                this.gastoData.expense_id = item.id
                $('#editGasto').modal('toggle')
            },
            editData() {
                window.axios.post('/api/editExpense', this.gastoData).then((response) => {
                    this.gastos[this.editIndex] = response.data.expense
                    $('#editGasto').modal('toggle')
                    this.gastoData = JSON.parse(JSON.stringify(this.defaultGastoData))
                }).catch((error) => {
                    // Solo se mostrara error en la consola
                    console.log(error)
                })
            },
            deleteItem(item) {
                window.axios.post('/api/deleteExpense', {
                    expense_id: item.id
                }).then(() => {
                    const index = this.gastos.indexOf(item)
                    this.gastos.splice(index, 1)
                }).catch((error) => {
                    // Solo se mostrara error en la consola
                    console.log(error)
                })
            }
        },
        mounted() {
            this.getExpenses()
            this.getEmployees()
            this.getExpenseCategory()
            this.getPaymentMethod()
        }
    }
</script>

<style scoped>

</style>
